#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2twelve4search.py">
#<abstract4xi abstract = "shoots to direction twelve"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2twelve4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2twelve4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2twelve4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4twelve

global count2ack4twelve
global count2nack4twelve
global count2found4twelve
global count2short4twelve

global current2series4twelve
global candidate2series4twelve

global fileobject4twelve  

global keys2profile4twelve
global key2profile4twelve

global left2find4twelve

global maxsize2ack4twelve    
global maxsize2file4twelve 
global max2short4twelve
global meansize2ack4twelve
global minsize2ack4twelve

global twelve2analyse4search

global profile2fetch4twelve

global right2find4twelve

global sumsize2ack4twelve    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4twelve = VersionKB4Xi['base2shoot4twelve']             # base internet address, None=local url

count2ack4twelve   = 0
count2nack4twelve  = 0
count2found4twelve = 0
count2short4twelve = 0

left2find4twelve = '('

max2short4twelve = VersionKB4Xi['max2short4twelve']
maxsize2file4twelve = VersionKB4Xi['maxsize2file4twelve']
maxsize2ack4twelve  = 0
meansize2ack4twelve = 0
minsize2ack4twelve  = 0

current2series4twelve = "current2series4twelve5dummy"
candidate2series4twelve  = "candidate2series4twelve5dummy"


twelve2analyse4search  = VersionKB4Xi['twelve2analyse4search']

profile2fetch4twelve = {}
profile2fetch4twelve [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4twelve [2] = '.jpg'
keys2profile4twelve = profile2fetch4twelve.keys()

right2find4twelve = ')'

sumsize2ack4twelve  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4twelve" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4twelve(target2explore4twelve):
    global count2ack4twelve
    global count2nack4twelve
    global count2found4twelve
    global count2short4twelve
    
    global fileobject4twelve 
       
    global keys2profile4twelve
    global key2profile4twelve
    
    global left2find4twelve

    global max2short4twelve    
    global maxsize2file4twelve     
    global maxsize2ack4twelve    
    global meansize2ack4twelve
    global minsize2ack4twelve
  
    global candidate2series4twelve
    global current2series4twelve
    
    
    global profile2fetch4twelve                         # extension for files
    
    global right2find4twelve
    
    global sumsize2ack4twelve    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4twelve = count2found4twelve + 1
    ack2debug4twelve = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4twelve)
    
    ack2profile = False
    for key2profile4twelve in keys2profile4twelve:
        if name2target[1] == profile2fetch4twelve[key2profile4twelve]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2TWELVE4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4twelve
        if ack2debug4twelve is True:
            print("(STEP 0A/33) OF SHOOT2TWELVE4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2TWELVE4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4twelve:
            count2nack4twelve = count2nack4twelve + 1
        else:
            count2ack4twelve = count2ack4twelve + 1
            sumsize2ack4twelve = sumsize2ack4twelve + size2file
            if size2file > maxsize2ack4twelve:
                maxsize2ack4twelve = size2file
            if ((size2file < minsize2ack4twelve) or (minsize2ack4twelve == 0)):
                print("(STEP 0B/33) OF SHOOT2TWELVE4SEARCH - USING MINSIZE2ACK4TWELVE: ", minsize2ack4twelve, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4TWELVE:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2twelve//d\twelvefly29july2012\twelvefly29july2012 (1).JPG 
                # USING MINSIZE2ACK4TWELVE:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2twelve//d\twelvefly29july2012\twelvefly29july2012 (2).JPG
                minsize2ack4twelve = size2file
                print("(STEP 0C/33) OF SHOOT2TWELVE4SEARCH - SET MINSIZE2ACK4TWELVE TO: ", minsize2ack4twelve, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4TWELVE TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2twelve//d\twelvefly29july2012\twelvefly29july2012 (1).JPG
                # SET MINSIZE2ACK4TWELVE TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2twelve//d\twelvefly29july2012\twelvefly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4twelve = target2explore4twelve
            if ack2debug4twelve is True:print("(STEP 1A/33) OF SHOOT2TWELVE4SEARCH - URL2WEB4TWELVE: ", url2web4twelve) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4twelve,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4twelve = url2web4twelve[0:index2edit] + string2use + url2web4twelve[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4twelve)
            shortname2web4twelve = name2web[0]
            if ack2debug4twelve is True:
                print("(STEP 1B/33) OF SHOOT2TWELVE4SEARCH - SHORTNAME2WEB4TWELVE: ", shortname2web4twelve)
                # 
            
            string2find4twelve = '/'
            ackall2found4twelve = False           
            while 1:
                if ackall2found4twelve is True:
                    break
                else:
                    index2find4twelve=str.find(shortname2web4twelve,string2find4twelve)   
                    if index2find4twelve == -1:
                        ackall2found4twelve = True
                    else:
                        shortname2web4twelve = shortname2web4twelve[index2find4twelve+1:]
                        
            if ack2debug4twelve is True:            
                print("(STEP 1C/33) OF SHOOT2TWELVE4SEARCH - SHORTNAME2WEB4TWELVE: ", shortname2web4twelve)
                # 
                
            ackall2found4twelve = False 
            while 1:
                if ackall2found4twelve is True:
                    break
                else:
                    index2left4twelve=str.find(shortname2web4twelve,left2find4twelve)
                    if index2left4twelve == -1:
                        current2series4twelve = shortname2web4twelve
                        if ack2debug4twelve is True:
                            print("(STEP 2A/33) OF SHOOT2TWELVE4SEARCH - CURRENT2SERIES4TWELVE: ", current2series4twelve) 
                            # 
                        ackall2found4twelve = True
                         
                    else:
                        index2right4twelve=str.find(shortname2web4twelve,right2find4twelve)
                        if index2right4twelve == -1:
                            ackall2found4twelve = True 
                        else:
                            candidate2series4twelve = shortname2web4twelve[0:index2left4twelve]
                            
                            index3find4twelve=str.find(shortname2web4twelve,current2series4twelve)
                            if index3find4twelve == -1:
                                
                                current2series4twelve = candidate2series4twelve
                                if ack2debug4twelve is True:
                                    print("(STEP 2B/33) OF SHOOT2TWELVE4SEARCH - CURRENT2SERIES4TWELVE: ", current2series4twelve) 
                                    # 
                                
                                count2short4twelve = 0
                                fileobject4twelve.write('<br />' + '\n')
                            else:
                                shortname2web4twelve = shortname2web4twelve[index2left4twelve:index2right4twelve+1]
                                if ack2debug4twelve is True:
                                    print("(STEP 2C/33) OF SHOOT2TWELVE4SEARCH - SHORTNAME2WEB4TWELVE: ", shortname2web4twelve)
                                    # 
                                
                                count2short4twelve = count2short4twelve + 1
                                if count2short4twelve >= max2short4twelve:
                                    count2short4twelve = 0
                                else:
                                    pass       
                            ackall2found4twelve = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4twelve is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4twelve.write('<br /><b>&raquo;</b><a href="' + url2web4twelve + '" target="_blank">' + shortname2web4twelve + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4twelve = twelve2analyse4search
                if ack2debug4twelve is True:
                    print("(STEP 3A/33) OF SHOOT2TWELVE4SEARCH - BASE2LOCAL4TWELVE: ", base2local4twelve)
                    #              
                ack2localtries4twelve = False                   
                while 1:
                    if ack2localtries4twelve is True:
                        break
                    else:
                        index2find4twelve=str.find(url2web4twelve,base2local4twelve)            
                        # 
                        #  
                        if index2find4twelve == -1:
                            ack2localtries4twelve = True
                        else:
                            if ack2debug4twelve is True:
                                print("(STEP 3B/33) OF SHOOT2TWELVE4SEARCH - BASE2BUILD4TWELVE: ", base2build4twelve)
                                # 
                            url2web4twelve = base2build4twelve + url2web4twelve[len(base2local4twelve):]
                            if ack2debug4twelve is True:
                                print("(STEP 3C/33) OF SHOOT2TWELVE4SEARCH - URL2WEB4TWELVE: ", url2web4twelve)
                                # 
                            
                            if count2short4twelve < 1: 
                                fileobject4twelve.write('<br /><b>&raquo;</b><a href="' + url2web4twelve + '" target="_blank">' + shortname2web4twelve + '</a>' + '\n')
                            else:
                                fileobject4twelve.write('<b>&raquo;</b><a href="' + url2web4twelve + '" target="_blank">' + shortname2web4twelve + '</a>\n')                            
                            ack2localtries4twelve = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2TWELVE4SEARCH FAILED, FILEOBJECT4TWELVE-WRITE-FAILED: ", str(fileobject4twelve), time4xi())
      
    else:
        
        count2nack4twelve = count2nack4twelve + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2twelve4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2twelve4search(queue2twelve = None, consumer_channel2twelve = None, publisher_channel2twelve = None, path2twelve = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4twelve
    global count2nack4twelve
    global count2found4twelve
    
    global fileobject4twelve    
    
    global maxsize2ack4twelve    
    global meansize2ack4twelve
    global minsize2ack4twelve
    global sumsize2ack4twelve    
    
    global maxsize2file4twelve 
    
    global profile2fetch4twelve                         # extension for files
    global keys2profile4twelve
    global key2profile4twelve

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2TWELVE4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2TWELVE4SEARCH -  QUEUE2TWELVE: ", queue2twelve)      
    # QUEUE2TWELVE:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2TWELVE4SEARCH -  CONSUMER_CHANNEL2TWELVE: ", consumer_channel2twelve)
    # CONSUMER_CHANNEL2TWELVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2TWELVE4SEARCH -  PUBLISHER_CHANNEL2TWELVE: ", publisher_channel2twelve)          
    # PUBLISHER_CHANNEL2TWELVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2twelve is None) or (consumer_channel2twelve is None) or (publisher_channel2twelve is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2TWELVE4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2TWELVE4SEARCH - QUEUE2TWELVE: ", queue2twelve)
        print("(STEP 1C/33) OF SHOOT2TWELVE4SEARCH - CONSUMER_CHANNEL2TWELVE: ", consumer_channel2twelve) 
        print("(STEP 1D/33) OF SHOOT2TWELVE4SEARCH - PUBLISHER_CHANNEL2TWELVE: ", publisher_channel2twelve)
        print("(STEP 1E/33) OF SHOOT2TWELVE4SEARCH - PATH2TWELVE: ", path2twelve)     
        
        return
 
    if (not (queue2twelve is None) and not(consumer_channel2twelve is None) and not(publisher_channel2twelve is None) and (path2twelve is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2TWELVE4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2TWELVE4SEARCH - QUEUE2TWELVE: ", queue2twelve)
        print("(STEP 2C/33) OF SHOOT2TWELVE4SEARCH - CONSUMER_CHANNEL2TWELVE: ", consumer_channel2twelve) 
        print("(STEP 2D/33) OF SHOOT2TWELVE4SEARCH - PUBLISHER_CHANNEL2TWELVE: ", publisher_channel2twelve)
        print("(STEP 2E/33) OF SHOOT2TWELVE4SEARCH - PATH2TWELVE: ", path2twelve)     
        return           

    if (not (queue2twelve is None) and not(consumer_channel2twelve is None) and not(publisher_channel2twelve is None) and not(path2twelve is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2TWELVE4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2TWELVE4SEARCH - QUEUE2TWELVE: ", queue2twelve)
        # QUEUE2TWELVE:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2TWELVE4SEARCH - CONSUMER_CHANNEL2TWELVE: ", consumer_channel2twelve)
        # CONSUMER_CHANNEL2TWELVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2TWELVE4SEARCH - PUBLISHER_CHANNEL2TWELVE: ", publisher_channel2twelve)
        # PUBLISHER_CHANNEL2TWELVE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2TWELVE4SEARCH - PATH2TWELVE: ", path2twelve)
        # PATH2TWELVE:  F://temp//yophotos//test2twelve//
       
        print("(STEP 4A/33) OF SHOOT2TWELVE4SEARCH - STARTING TO WALK PATH2TWELVE: ", path2twelve)   
        # STARTING TO WALK PATH2TWELVE:  F://temp//yophotos//test2twelve//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4twelve = None
        try:
            name2index4twelve = "index2xxxxxxxx4yo.html"
            path2index4twelve = path2twelve + name2index4twelve
            print("(Step 4B/33) OF SHOOT2TWELVE4SEARCH - SET PATH2INDEX4TWELVE TO: ", path2index4twelve)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4TWELVE: ", path2index4twelve)          
            #                    
        fileobject4twelve = None
        try:
            fileobject4twelve = open(path2index4twelve,'w')
            print("(Step 4C/33) OF SHOOT2TWELVE4SEARCH - OPENED OUTPUT: ", fileobject4twelve)
            # SHOOT2TWELVE4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2twelve//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4twelve)         
            # 
        try:                
            fileobject4twelve.write('<html>\n')
            
            fileobject4twelve.write('<style type="text/css" media="all">\n')
            fileobject4twelve.write(' @import "http://www.yourtwelvexi.org/css/halongbay.css";\n')
            fileobject4twelve.write('</style> \n')
            fileobject4twelve.write('<p>\n')
            fileobject4twelve.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4twelve.write('<br /><a id="000">yourtwelve<b>&Xi;</b> @Content</a>\n')
            fileobject4twelve.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4twelve.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4twelve)         
            #      
        
        
        KB2name4twelve = {}
        key2name4twelve = 0
                 
        for file2walk in DirectoryWalker(path2twelve):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4twelve [key2name4twelve] = file2walk
                    print ("KB2NAME4TWELVE[", key2name4twelve, "]: ", KB2name4twelve [key2name4twelve])
                    # 
                    
                    key2name4twelve = key2name4twelve + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2TWELVE4SEARCH - FAILED UPDATING KB2NAME4TWELVE WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4twelve(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4twelve.write('<br /> \n')
            fileobject4twelve.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4twelve.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4twelve.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4twelve.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4twelve.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4twelve.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4twelve.write('</p>\n')
            # 
            fileobject4twelve.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4twelve)         
            #            
        try:    
            fileobject4twelve.close()
            print("(Step 4C/33) OF SHOOT2TWELVE4SEARCH - CLOSED OUTPUT: ", fileobject4twelve)         
            # SHOOT2TWELVE4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2twelve//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4twelve)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2TWELVE4SEARCH - STARTING TO ANALYSE KB2NAME4TWELVE: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4TWELVE:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4twelve  = {}
        AlphaKB4twelve['a'] = {}
        AlphaKB4twelve['b'] = {}
        AlphaKB4twelve['c'] = {}
        AlphaKB4twelve['d'] = {}
        AlphaKB4twelve['e'] = {}
        AlphaKB4twelve['f'] = {}
        AlphaKB4twelve['g'] = {}
        AlphaKB4twelve['h'] = {}
        AlphaKB4twelve['i'] = {}
        AlphaKB4twelve['j'] = {}
        AlphaKB4twelve['k'] = {}
        AlphaKB4twelve['l'] = {}
        AlphaKB4twelve['m'] = {}
        AlphaKB4twelve['n'] = {}
        AlphaKB4twelve['o'] = {}
        AlphaKB4twelve['p'] = {}
        AlphaKB4twelve['q'] = {}
        AlphaKB4twelve['r'] = {}
        AlphaKB4twelve['s'] = {}
        AlphaKB4twelve['t'] = {}
        AlphaKB4twelve['u'] = {}
        AlphaKB4twelve['v'] = {}
        AlphaKB4twelve['w'] = {}
        AlphaKB4twelve['x'] = {}
        AlphaKB4twelve['y'] = {}
        AlphaKB4twelve['z'] = {} 
        keys2AlphaKB4twelve = AlphaKB4twelve.keys()
        key2AlphaKB4twelve  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4twelve = len(path2twelve)
        # 
        
        keys2name4twelve = KB2name4twelve.keys()
                
        for key2name4twelve in sorted(keys2name4twelve):
            # 
            name2optimize4twelve = KB2name4twelve[key2name4twelve]
            # 
            shortcut2level4twelve = name2optimize4twelve[len2cut4twelve:]
            # 
            len2shortcut4twelve = len(shortcut2level4twelve)
            if len2shortcut4twelve == 1:
                try:
                    # LEVEL TWELVE CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4twelve in keys2AlphaKB4twelve:
                        KB2level1[key2level1] = shortcut2level4twelve
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2TWELVE4SEARCH ** WARNING - SHORTCUT2LEVEL4TWELVE: ", shortcut2level4twelve, " NOT IN KEYS2ALPHAKB4TWELVE: ", keys2AlphaKB4twelve)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2TWELVE4SEARCH *** FAILED - SHORTCUT2LEVEL4TWELVE: ", shortcut2level4twelve)      
            else:
                try:
                    
                    string2search4twelve = '\\'
                    shortcut2level4twelve = shortcut2level4twelve[2:]
                    
                    index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                    if index2level4twelve == -1:
                         
                        KB2level2[key2level2] = shortcut2level4twelve
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4twelve = shortcut2level4twelve[index2level4twelve+1:]
                        index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                        if index2level4twelve == -1:
                            KB2level3[key2level3] = shortcut2level4twelve
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4twelve = shortcut2level4twelve[index2level4twelve+1:]
                            index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                            if index2level4twelve == -1:
                                KB2level4[key2level4] = shortcut2level4twelve
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4twelve = shortcut2level4twelve[index2level4twelve+1:]
                                index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                                if index2level4twelve == -1:
                                    KB2level5[key2level5] = shortcut2level4twelve
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4twelve = shortcut2level4twelve[index2level4twelve+1:]
                                    index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                                    if index2level4twelve == -1:
                                        KB2level6[key2level6] = shortcut2level4twelve
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4twelve = shortcut2level4twelve[index2level4twelve+1:]
                                        index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                                        if index2level4twelve == -1:
                                            KB2level7[key2level7] = shortcut2level4twelve
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4twelve = shortcut2level4twelve[index2level4twelve+1:]
                                            index2level4twelve=str.find(shortcut2level4twelve,string2search4twelve)
                                            if index2level4twelve == -1:
                                                KB2level8[key2level8] = shortcut2level4twelve
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2TWELVE4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4TWELVE: ", shortcut2level4twelve)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2TWELVE4SEARCH *** FAILED - SHORTCUT2LEVEL4TWELVE: ", shortcut2level4twelve)   
        
        print ("(Step 6A/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # twelvefly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2TWELVE4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2TWELVE4SEARCH - COUNT2ACK4TWELVE; ", count2ack4twelve)
            # COUNT2ACK4TWELVE;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2TWELVE4SEARCH - COUNT2NACK4TWELVE; ", count2nack4twelve)
            # COUNT2NACK4TWELVE;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2TWELVE4SEARCH - COUNT2FOUND4TWELVE: ", count2found4twelve)
            # COUNT2FOUND4TWELVE:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2TWELVE4SEARCH - FOUND MAX SIZE: ", maxsize2ack4twelve)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2TWELVE4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4twelve)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4twelve == 0:
                meansize2ack4twelve = 0
                print ("(Step 7G1/33) OF SHOOT2TWELVE4SEARCH - MEAN SIZE SET: ", meansize2ack4twelve)
                #  
            else:       
                meansize2ack4twelve = int(sumsize2ack4twelve / count2ack4twelve)
                print ("(Step 7G2/33) OF SHOOT2TWELVE4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4twelve, ", WHERE SUMSIZE2ACK4TWELVE: ", sumsize2ack4twelve, " COUNT2ACK4TWELVE: ", count2ack4twelve)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4TWELVE:  10944512  COUNT2ACK4TWELVE:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4twelve < maxsize2file4twelve:
                print ("(Step 7H/33) OF SHOOT2TWELVE4SEARCH - MIN SIZE MET: ", minsize2ack4twelve)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2TWELVE4SEARCH ** MIN DEFINED: ", minsize2ack4twelve, " EQUALS TO MAXSIZE2FILE4TWELVE: ", maxsize2file4twelve)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2TWELVE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2TWELVE4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2TWELVE4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2TWELVE4SEARCH - QUEUE2TWELVE: ", queue2twelve)
        print("(STEP 7Z3/33) OF SHOOT2TWELVE4SEARCH - CONSUMER_CHANNEL2TWELVE: ", consumer_channel2twelve) 
        print("(STEP 7Z4/33) OF SHOOT2TWELVE4SEARCH - PUBLISHER_CHANNEL2TWELVE: ", publisher_channel2twelve)
        print("(STEP 7Z5/33) OF SHOOT2TWELVE4SEARCH - PATH2TWELVE: ", path2twelve)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.twelvexi.com; www.yourtwelvexi.com; www.yourtwelvexi.org; www.twelve2xi.com/; www.twelve4xi.com/; www.twelve8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2twelve4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
